'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EntityType = exports.EntityJSONType = exports.Entity = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

var _tcomb = require('tcomb');

var _model = require('./model');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var maybeDate = (0, _tcomb.maybe)(_tcomb.Date);

var Entity = exports.Entity = function (_Model) {
  _inherits(Entity, _Model);

  /**
   * @param {{$id: string, $context: URIValue, $createdAt: Date|undefined, $updatedAt: Date|undefined, $deletedAt: Date|undefined}} fields
   */
  function Entity(fields) {
    _classCallCheck(this, Entity);

    var $id = fields.$id,
        $createdAt = fields.$createdAt,
        $updatedAt = fields.$updatedAt,
        $deletedAt = fields.$deletedAt;

    var _this = _possibleConstructorReturn(this, (Entity.__proto__ || Object.getPrototypeOf(Entity)).call(this, fields));

    (0, _tcomb.String)($id);
    maybeDate($createdAt);
    maybeDate($updatedAt);
    maybeDate($deletedAt);
    _this.$id = $id;
    _this.$createdAt = $createdAt;
    _this.$updatedAt = $updatedAt;
    _this.$deletedAt = $deletedAt;
    return _this;
  }

  /**
   * @returns {{$id: string, $context: string, $links: Array<Link>, $createdAt: string|undefined, $updatedAt: string|undefined, $deletedAt: string|undefined}}
   */


  _createClass(Entity, [{
    key: 'toJSON',
    value: function toJSON() {
      return (0, _lodash.merge)(_get(Entity.prototype.__proto__ || Object.getPrototypeOf(Entity.prototype), 'toJSON', this).call(this), {
        $id: this.$id,
        $createdAt: this.$createdAt ? this.$createdAt.toISOString() : undefined,
        $updatedAt: this.$updatedAt ? this.$updatedAt.toISOString() : undefined,
        $deletedAt: this.$deletedAt ? this.$deletedAt.toISOString() : undefined
      });
    }

    /**
     * @param {{$id: string, $context: string, $links: Array<Link>, $createdAt: string|undefined, $updatedAt: string|undefined, $deletedAt: string|undefined}} data
     * @returns {Entity}
     */

  }, {
    key: '$modifiedAt',


    /**
     * Returns the timestamp when the model was modified the last time, which is the latest value of
     * createdAt, updatedAt or deletedAt
     *
     * @returns {Date|undefined}
     */
    get: function get() {
      if (this.$deletedAt) {
        return this.$deletedAt;
      }
      if (this.$updatedAt) {
        return this.$updatedAt;
      }
      return this.$createdAt;
    }
  }], [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      EntityJSONType(data);
      return new Entity((0, _lodash.merge)(_get(Entity.__proto__ || Object.getPrototypeOf(Entity), 'fromJSON', this).call(this, data), {
        $id: data.$id,
        $context: new _uri2.default(data.$context),
        $createdAt: data.$createdAt ? new Date(data.$createdAt) : undefined,
        $updatedAt: data.$updatedAt ? new Date(data.$updatedAt) : undefined,
        $deletedAt: data.$deletedAt ? new Date(data.$deletedAt) : undefined
      }));
    }
  }]);

  return Entity;
}(_model.Model);

var EntityJSONType = exports.EntityJSONType = (0, _tcomb.struct)({
  $id: _tcomb.String,
  $createdAt: (0, _tcomb.maybe)(_tcomb.String),
  $updatedAt: (0, _tcomb.maybe)(_tcomb.String),
  $deletedAt: (0, _tcomb.maybe)(_tcomb.String)
}, 'EntityJSONType');
var EntityType = exports.EntityType = (0, _tcomb.irreducible)('EntityType', function (x) {
  return x instanceof Entity;
});