'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LinkType = exports.LinkJSONType = exports.Link = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tcomb = require('tcomb');

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var $context = new _uri2.default('https://github.com/ResourcefulHumans/staRHs-models#Link');

var Link = exports.Link = function () {
  /**
   * @param {URIValue} href The URL to retrieve the link
   * @param {URIValue} subject The context of the linked item
   * @param {boolean} list True if the linked item is a list
   * @param {string} rel Label for the relation
   */
  function Link(href, subject) {
    var list = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var rel = arguments[3];

    _classCallCheck(this, Link);

    _uri2.default.Type(href);
    _uri2.default.Type(subject);
    (0, _tcomb.Boolean)(list);
    (0, _tcomb.maybe)(_tcomb.String)(rel);
    this.$context = $context;
    this.href = href;
    this.subject = subject;
    this.list = list;
    this.rel = rel;
  }

  /**
   * @returns {{$context: string, subject: string, href: string, list: boolean|undefined, rel: string|undefined}}}
   */


  _createClass(Link, [{
    key: 'toJSON',
    value: function toJSON() {
      var d = {
        $context: this.$context.toString(),
        subject: this.subject.toString(),
        href: this.href.toString()
      };
      if (this.list) d.list = true;
      if (this.rel) d.rel = this.rel;
      return d;
    }

    /**
     * @param {{$context: string, subject: string, href: string, list: boolean|undefined, rel: string|undefined}} data
     * @returns {Link}
     */

  }], [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      LinkJSONType(data);
      var href = data.href,
          subject = data.subject,
          list = data.list,
          rel = data.rel;

      return new Link(new _uri2.default(href), new _uri2.default(subject), list, rel);
    }

    /**
     * @returns {URIValue}
     */

  }, {
    key: '$context',
    get: function get() {
      return $context;
    }
  }]);

  return Link;
}();

var LinkJSONType = exports.LinkJSONType = (0, _tcomb.struct)({
  $context: (0, _tcomb.refinement)(_tcomb.String, function (s) {
    return s === $context.toString();
  }, 'LinkContext'),
  subject: _tcomb.String,
  href: _tcomb.String,
  list: (0, _tcomb.maybe)(_tcomb.Boolean),
  rel: (0, _tcomb.maybe)(_tcomb.String)
}, 'LinkJSONType');
var LinkType = exports.LinkType = (0, _tcomb.irreducible)('LinkType', function (x) {
  return x instanceof Link;
});