'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModelType = exports.ModelJSONType = exports.Model = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

var _tcomb = require('tcomb');

var _link = require('./link');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LinkListType = (0, _tcomb.list)(_link.Link);

var Model = exports.Model = function () {
  /**
   * @param {{$context: URIValue}} fields
   */
  function Model(fields) {
    _classCallCheck(this, Model);

    var $context = fields.$context,
        $links = fields.$links;

    _uri2.default.Type($context);
    LinkListType($links || []);
    this.$context = $context;
    this.$links = $links || [];
  }

  /**
   * @returns {{$context: string, $links: Array<Link>}}
   */


  _createClass(Model, [{
    key: 'toJSON',
    value: function toJSON() {
      var d = {
        $context: this.$context.toString()
      };
      if (this.$links.length) d.$links = this.$links.map(function (link) {
        return link.toJSON();
      });
      return d;
    }

    /**
     * @param {{$context: string}} data
     * @returns {Model}
     */

  }], [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      ModelJSONType(data);
      return new Model({
        $context: new _uri2.default(data.$context),
        $links: data.$links ? data.$links.map(function (l) {
          return _link.Link.fromJSON(l);
        }) : []
      });
    }
  }]);

  return Model;
}();

var ModelJSONType = exports.ModelJSONType = (0, _tcomb.struct)({
  $context: _tcomb.String,
  $links: (0, _tcomb.maybe)((0, _tcomb.list)(_link.LinkJSONType))
}, 'ModelJSONType');
var ModelType = exports.ModelType = (0, _tcomb.irreducible)('ModelType', function (x) {
  return x instanceof Model;
});