'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProfileType = exports.ProfileJSONType = exports.Profile = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _tcomb = require('tcomb');

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

var _email = require('rheactor-value-objects/email');

var _email2 = _interopRequireDefault(_email);

var _entity = require('./entity');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var $context = new _uri2.default('https://github.com/ResourcefulHumans/staRHs-models#Profile');

var Profile = exports.Profile = function (_Entity) {
  _inherits(Profile, _Entity);

  /**
   * @param {{$id: string, email: EmailValue, firstname: string, lastname: string, avatar: URIValue, $links: Array.<Link>}} fields
   */
  function Profile(fields) {
    _classCallCheck(this, Profile);

    var email = fields.email,
        firstname = fields.firstname,
        lastname = fields.lastname,
        avatar = fields.avatar;

    var _this = _possibleConstructorReturn(this, (Profile.__proto__ || Object.getPrototypeOf(Profile)).call(this, (0, _lodash.merge)(fields, { $context: $context })));

    (0, _tcomb.String)(firstname);
    (0, _tcomb.String)(lastname);
    _email2.default.Type(email);
    (0, _tcomb.maybe)(_uri2.default.Type)(avatar);
    _this.email = email;
    _this.firstname = firstname;
    _this.lastname = lastname;
    _this.avatar = avatar;
    return _this;
  }

  /**
   * @returns string
   */


  _createClass(Profile, [{
    key: 'toJSON',


    /**
     * @returns {{$id: string, email: string, firstname: string, lastname: string, avatar: (string|undefined), $context: string, $links: Array<{href: string, $context: string}>}}
     */
    value: function toJSON() {
      return (0, _lodash.merge)(_get(Profile.prototype.__proto__ || Object.getPrototypeOf(Profile.prototype), 'toJSON', this).call(this), {
        email: this.email.toString(),
        firstname: this.firstname,
        lastname: this.lastname,
        avatar: this.avatar ? this.avatar.toString() : undefined
      });
    }

    /**
     * @param {{$id: string, email: string, firstname: string, lastname: string, avatar: string, $links: Array<{href: string, $context: string}>}} data
     * @returns {Profile}
     */

  }, {
    key: 'name',
    get: function get() {
      var name = this.firstname;
      if (name.length) name = name + ' ';
      name = name + this.lastname;
      return name;
    }
  }], [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      ProfileJSONType(data);
      var email = data.email,
          firstname = data.firstname,
          lastname = data.lastname,
          avatar = data.avatar;

      return new Profile((0, _lodash.merge)(_get(Profile.__proto__ || Object.getPrototypeOf(Profile), 'fromJSON', this).call(this, data), {
        email: new _email2.default(email),
        firstname: firstname,
        lastname: lastname,
        avatar: avatar ? new _uri2.default(avatar) : avatar
      }));
    }

    /**
     * @returns {URIValue}
     */

  }, {
    key: '$context',
    get: function get() {
      return $context;
    }
  }]);

  return Profile;
}(_entity.Entity);

var ProfileJSONType = exports.ProfileJSONType = (0, _tcomb.struct)({
  $context: (0, _tcomb.refinement)(_tcomb.String, function (s) {
    return s === $context.toString();
  }, 'ProfileContext'),
  email: _tcomb.String,
  firstname: _tcomb.String,
  lastname: _tcomb.String,
  avatar: _tcomb.String
}, 'ProfileJSONType');
var ProfileType = exports.ProfileType = (0, _tcomb.irreducible)('ProfileType', function (x) {
  return x instanceof Profile;
});