'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StaRHsStatusType = exports.StaRHsStatusJSONType = exports.StaRHsStatus = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _tcomb = require('tcomb');

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

var _model = require('./model');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ZeroOrPositiveIntegerType = (0, _tcomb.refinement)(_tcomb.Number, function (n) {
  return n >= 0 && n % 1 === 0;
}, 'ZeroOrPositiveIntegerType');
var $context = new _uri2.default('https://github.com/ResourcefulHumans/staRHs-models#StaRHsStatus');

var StaRHsStatus = exports.StaRHsStatus = function (_Model) {
  _inherits(StaRHsStatus, _Model);

  /**
   * @param {{cycleShared: number, cycleReceived: number, cycleLeft: number, totalShared: number, totalReceived: number}} fields
   */
  function StaRHsStatus(fields) {
    _classCallCheck(this, StaRHsStatus);

    var _this = _possibleConstructorReturn(this, (StaRHsStatus.__proto__ || Object.getPrototypeOf(StaRHsStatus)).call(this, (0, _lodash.merge)(fields, { $context: $context })));

    var cycleShared = fields.cycleShared,
        cycleReceived = fields.cycleReceived,
        cycleLeft = fields.cycleLeft,
        totalShared = fields.totalShared,
        totalReceived = fields.totalReceived;

    ZeroOrPositiveIntegerType(cycleShared);
    ZeroOrPositiveIntegerType(cycleReceived);
    ZeroOrPositiveIntegerType(cycleLeft);
    ZeroOrPositiveIntegerType(totalShared);
    ZeroOrPositiveIntegerType(totalReceived);
    _this.cycleShared = cycleShared;
    _this.cycleReceived = cycleReceived;
    _this.cycleLeft = cycleLeft;
    _this.totalShared = totalShared;
    _this.totalReceived = totalReceived;
    return _this;
  }

  /**
   * @returns {{cycleShared: number, cycleReceived: number, cycleLeft: number, totalShared: number, totalReceived: number, $context: string, $links: Array<{href: string, $context: string}>}}
   */


  _createClass(StaRHsStatus, [{
    key: 'toJSON',
    value: function toJSON() {
      return (0, _lodash.merge)(_get(StaRHsStatus.prototype.__proto__ || Object.getPrototypeOf(StaRHsStatus.prototype), 'toJSON', this).call(this), {
        cycleShared: this.cycleShared,
        cycleReceived: this.cycleReceived,
        cycleLeft: this.cycleLeft,
        totalShared: this.totalShared,
        totalReceived: this.totalReceived
      });
    }

    /**
     * @param {{cycleShared: number, cycleReceived: number, cycleLeft: number, totalShared: number, totalReceived: number}} data
     * @returns {StaRHsStatus}
     */

  }], [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      StaRHsStatusJSONType(data);
      return new StaRHsStatus((0, _lodash.merge)(_get(StaRHsStatus.__proto__ || Object.getPrototypeOf(StaRHsStatus), 'fromJSON', this).call(this, data), data));
    }

    /**
     * @returns {URIValue}
     */

  }, {
    key: '$context',
    get: function get() {
      return $context;
    }
  }]);

  return StaRHsStatus;
}(_model.Model);

var StaRHsStatusJSONType = exports.StaRHsStatusJSONType = (0, _tcomb.struct)({
  $context: (0, _tcomb.refinement)(_tcomb.String, function (s) {
    return s === $context.toString();
  }, 'StaRHsStatusContext'),
  cycleShared: _tcomb.Number,
  cycleReceived: _tcomb.Number,
  cycleLeft: _tcomb.Number,
  totalShared: _tcomb.Number,
  totalReceived: _tcomb.Number
}, 'StaRHsStatusJSONType');
var StaRHsStatusType = exports.StaRHsStatusType = (0, _tcomb.irreducible)('StaRHsStatusType', function (x) {
  return x instanceof StaRHsStatus;
});