'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StatusType = exports.StatusJSONType = exports.Status = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tcomb = require('tcomb');

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var $context = new _uri2.default('https://github.com/ResourcefulHumans/staRHs-models#Status');

var Status = exports.Status = function () {
  /**
   * @param {{status: string, time: Date, version: string}} fields
   */
  function Status(fields) {
    _classCallCheck(this, Status);

    var status = fields.status,
        time = fields.time,
        version = fields.version;

    (0, _tcomb.String)(status);
    (0, _tcomb.Date)(time);
    (0, _tcomb.String)(version);
    this.status = status;
    this.time = time;
    this.version = version;
    this.$context = this.constructor.$context;
  }

  /**
   * @returns {{status: string, time: string, version: string, $context: string}}
   */


  _createClass(Status, [{
    key: 'toJSON',
    value: function toJSON() {
      return {
        status: this.status,
        time: this.time.toISOString(),
        version: this.version,
        $context: this.$context.toString()
      };
    }

    /**
     * @param {{status: string, time: Date}} data
     * @returns {Status}
     */

  }], [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      StatusJSONType(data);
      var status = data.status,
          time = data.time,
          version = data.version;

      return new Status({
        status: status,
        time: new Date(time),
        version: version
      });
    }

    /**
     * @returns {URIValue}
     */

  }, {
    key: '$context',
    get: function get() {
      return $context;
    }
  }]);

  return Status;
}();

var StatusJSONType = exports.StatusJSONType = (0, _tcomb.struct)({
  $context: (0, _tcomb.refinement)(_tcomb.String, function (s) {
    return s === $context.toString();
  }, 'StatusContext'),
  status: _tcomb.String,
  time: _tcomb.String,
  version: _tcomb.String
}, 'StatusJSONType');
var StatusType = exports.StatusType = (0, _tcomb.irreducible)('StatusType', function (x) {
  return x instanceof Status;
});